import os
import os
import xml.etree.ElementTree as ET


def create_xml_string(directory):
    root = ET.Element("Group")
    files = ET.SubElement(root, "Files")
    for dirpath, dirnames, filenames in os.walk(directory):
        for filename in filenames:
            if filename.endswith(('.c')):
                file_elem = ET.SubElement(files, "File")

                # Extract file name and path
                file_name = filename
                file_path = os.path.relpath(os.path.join(dirpath, filename), directory)
                file_path = f"../{file_path.replace(os.sep, '/')}"

                # Adding elements to File
                file_name_elem = ET.SubElement(file_elem, "FileName")
                file_name_elem.text = file_name
                file_name_elem.tail = "\n"  # Add a line break after </FileName>

                file_type_elem = ET.SubElement(file_elem, "FileType")
                file_type_elem.text = "1"  # Assuming a constant FileType value of 1
                file_type_elem.tail = "\n"  # Add a line break after </FileType>

                file_path_elem = ET.SubElement(file_elem, "FilePath")
                file_path_elem.text = file_path
                file_path_elem.tail = "\n"  # Add a line break after </FilePath>

                ET.SubElement(files, "").tail = "\n"  # Add a line break after each File element

    return ET.tostring(root, encoding="unicode", method="xml")


if __name__ == "__main__":

    #for root, dirs, files in os.walk(".", topdown=False):
    #    for name in files:
    #        names = name.split("/")
    #        File = f"<FileName>{names[0]}</FileName>"
    #        print(File)
    #    for name in dirs:
    #        #print(os.path.join(root, name))
    #        FilePath = f"<FilePath>{os.path.join(root, name)}<FilePath>"
    #        print(FilePath)

    #group_name = "<GroupName>Drivers/lvgl</GroupName>"
    #FileType = "<FileType>1</FileType>"
    #Files = "Files"

    # Example usage:
    directory_path = "."
    xml_string = create_xml_string(directory_path)
    
    # Remove empty tags (<></>) from the XML string
    xml_string = xml_string.replace("< />", "")


    # Writing the XML string to a file
    with open("out.txt", "w") as file:
        file.write(xml_string)


